



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于spring事务注解实战</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于spring事务注解实战</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 19:44:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1.概述</h1>
<p>spring的事务注解@Transaction 相信很多人都用过，而@Transaction 默认配置适合80%的配置。</p>
<p>本篇文章不是对spring注解事务做详细介绍，而是解决一些实际场景下遇到的问题</p>
<p>spring事务注解的基本原理</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1055208/201803/1055208-20180316120820674-2029592173.png" /></p>
<p>下面针对是否需要开启事务和是否需要回滚事务在特定场景下的介绍</p>
<h1>2.事务回滚</h1>
<h2>2.1 默认回滚策略</h2>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@Transactional<br />
public void rollback() throws SQLException {<br />
    // update db<br />
    throw new SQLException("exception");<br />
}</pre>
</div>
</div>
</div>
</div>
<p>上述代码事务会回滚吗？不会的，就算抛出SQLException了，但是之前的数据库操作依然会提交，原因就是@Transactional默认情况下只回滚RuntimeException和Error。</p>
<h2>2.2 指定回滚异常</h2>
<p>因此，如果要指定哪些异常需要回滚，则通过配置@Transactional中rollbackFor，例如</p>
<div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@Transactional(rollbackFor = {SQLException.class})<br />
public void rollback() throws SQLException {<br />
    // update db<br />
    throw new SQLException("exception");<br />
}</pre>
</div>

</div>
</div>
</div>
</div>
<p>按照上面例子，那指定的SQLException，当抛出RuntimeException的时候，还会回滚吗？</p>
<div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@Transactional(rollbackFor = {SQLException.class})<br />
public void rollback() throws SQLException {<br />
    // update db<br />
    throw new Runtime("exception");<br />
}</pre>
</div>
</div>
</div>
</div>
</div>
<p>还是会回滚的。</p>
<h2>2.3 事务嵌套的回滚</h2>
<p>假设有下面的逻辑，事务会回滚吗（或者说 updateA,updateB,updateC）哪些更新会提交</p>
<div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@Transactional<br />
public void rollback() {<br />
    // updateA<br />
    try{<br />
        selfProxy.innelTransaction()<br />
    }catch(RuntimeException e){<br />
        //do nothing<br />
    }<br />
    //updateC<br />
}

@Transactional<br />
public void innelTransaction() throws SQLException {<br />
    // updateB<br />
    throw new RuntimeException("exception");<br />
}</pre>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
<div>
<p>答案是会回滚，因为内部事务触发回滚，当前事务被标记为&nbsp;rollback-only，</p>
<p>当外部事务提交的时候，Spring抛出以下异常，同时回滚外部事务</p>
<div>
<div>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>
<div><code>org.springframework.transaction.UnexpectedRollbackException: Transaction rolled back because it has been marked as rollback-only</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<div>&nbsp;</div>
<h2>2.4 小结</h2>
<p>所以，在需要事务回滚的时候，最好还是抛出RuntimeException,并且不要在代码中捕获此类异常</p>
<h1>三、事务传播性</h1>
<p>@Transaction中的propagation的可以配置事务的传播性，网上介绍的很多，就直接复制一段</p>
<pre class="prettyprint linenums"><code>PROPAGATION_REQUIRED--支持当前事务，如果当前没有事务，就新建一个事务。这是最常见的选择。 (也是默认策略)<br />
PROPAGATION_SUPPORTS--支持当前事务，如果当前没有事务，就以非事务方式执行。<br />
PROPAGATION_MANDATORY--支持当前事务，如果当前没有事务，就抛出异常。<br />
PROPAGATION_REQUIRES_NEW--新建事务，如果当前存在事务，把当前事务挂起。<br />
PROPAGATION_NOT_SUPPORTED--以非事务方式执行操作，如果当前存在事务，就把当前事务挂起。<br />
PROPAGATION_NEVER--以非事务方式执行，如果当前存在事务，则抛出异常。<br />
</code></pre>
<h2>3.1 如何在事务中读取最新配置</h2>
<p>有时候需要在一个事务中，读取最新数据（默认是读取事务开始前的快照）。其实很简单，只要使用上面PROPAGATION_NOT_SUPPORTED传播性就可以了。</p>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@Transactional<br />
public void transaction() throws SQLException {<br />
    // do something<br />
    selfProxy.queryNewValue();<br />
}

@Transactional(propagation = Propagation.NOT_SUPPORTED)<br />
public void queryNewValue() throws SQLException {<br />
    //查询数据中的最新值<br />
}&nbsp;</pre>
</div>
</div>
</div>
</div>
<h1>四、内部调用事务方法</h1>
<p>事务注解的实质就是在创建一个动态代理，在调用事务方法前开启事务，在事务方法结束以后决定是事务提交还是回滚。</p>
<p>因此，直接在类内部中调用事务方法，是不会经过动态代理的</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1055208/201803/1055208-20180309165042456-532167462.png" /></p>
<p>。 因此，如果要使方法B点事务生效，必须这样</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1055208/201803/1055208-20180309165117679-1753916897.png" /></p>
<h2>4.1 解决办法</h2>
<p>解决思路：需要在内部调用方法B的时候，找到当前类的代理类，用代理类去调用方法B</p>
<h3>4.1.1 解决办法1</h3>
<div>&nbsp;</div>
<div>
<pre class="prettyprint linenums">@Service<br />
public class MyService{<br />
    @Transactional<br />
    public void transaction(){<br />
        // do something<br />
        ((MyService) AopContext.currentProxy()).queryNewValue();<br />
    }

    @Transactional(propagation = Propagation.NOT_SUPPORTED)<br />
    public void queryNewValue(){<br />
        //查询数据中的最新值<br />
    }<br />
}</pre>
</div>
<p>通过AopContext.currentProxy()可以拿到当前类的代理类，但是要使用这个时候，必须在启动类上加上</p>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">@EnableAspectJAutoProxy(exposeProxy=true)</pre>
</div>
</div>
</div>
</div>
<h3>4.1.2 解决办法2</h3>
<p>既然是要拿到当前代理类,那其实直接在Spring的容器里面去拿也可以啊。在spring中拿Bean的方法大致有2种</p>
<h4>通过注入</h4>
<div>
<pre class="prettyprint linenums">@Service<br />
public class MyService{<br />
    @Autowired<br />
    private MyService self;<br />
    @Transactional<br />
    public void transaction() {<br />
        // do something<br />
        self.queryNewValue();<br />
    }

    @Transactional(propagation = Propagation.NOT_SUPPORTED)<br />
    public void queryNewValue() {<br />
        //查询数据中的最新值<br />
    }<br />
}</pre>
</div>
<p>tips:spring现在对一些循环依赖是提供支持的，简单来说，满足：</p>
<ol><li>Bean是单例</li>
<li>注入的方式不是构造函数注入</li></ol>
<h4>通过BeanFactory</h4>
<div>
<pre class="prettyprint linenums">@Service<br />
public class MyService implements BeanFactoryAware{<br />
    private MyService self;

    @Transactional<br />
    public void transaction(){<br />
        // do something<br />
        self.queryNewValue();<br />
    }

    @Transactional(propagation = Propagation.NOT_SUPPORTED)<br />
    public void queryNewValue() {<br />
        //查询数据中的最新值<br />
    }

     @Override<br />
    public void setBeanFactory(BeanFactory beanFactory) throws BeansException {<br />
        self = beanFactory.getBean(MyService.class);<br />
    }<br />
}</pre>
</div>
<h2>4.2 需要注意的地方</h2>
<ul><ul><li>使用@Transaction注解的方法，必须用public来修饰。</li>
<li>其实不止是@Transaction，其他类似@Cacheable,@Retryable等依赖spring proxy也必须使用上述方式达到内部调用。</li>
<li>@Transactional,@Async放在同一个类中，如果使用Autowire注入会循环依赖，而使用BeanFactoryAware会使得@Transactional无效</li></ul></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvve4yq.html">Java 消息摘要 散列 MD5 SHA</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql16v09.html">【jQuery】scroll  滚动到顶部</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwl3pk9.html">mstsc 远程序桌面登录的 c&num;开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96yo0j8.html">iOS的触摸事件的用法以及和手势识别器的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy0x228.html">WCF在编译出现 &OpenCurlyDoubleQuote;错误 3 命令&OpenCurlyDoubleQuote;时解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlxeg1q.html">Android 数据库的事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xnr08.html">Velocity&lpar;8&rpar;&mdash;&mdash;引入指令和&num;Stop指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8enzdj8.html">easyui datagrid 获取 title</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd2dkdq.html">【BZOJ】【2480】【SPOJ 3105】Mod</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7k009.html">CSS学习笔记&mdash;&mdash;定位position属性的学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoo7n3q.html">Android文本Flood it游戏源代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg0rxq.html">【Ubuntu 16】安装nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7pe59.html">Android远程桌面助手&lpar;B1371&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd2d2j9.html">js获取当前url中参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvryel8.html">Rabbit五种消息队列学习（二） &ndash; 简单队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnmozq.html">asp&period;net mvc5轻松实现插件式开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldjreq.html">SqlServer 添加用户 添加角色 分配权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j13vne9.html">【tomcat】启动报错：Failed to initialize end point associated with ProtocolHandler &lbrack;&amp;quot&semi;http-apr-8080&amp;quot&semi;&rsqb; java&period;lang&period;Exception&colon; Socket bind failed  和java&period;net&period;BindException&colon; Address already in use&colon; JVM&lowbar;Bind错误解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r3gz48.html">Apache 配置Https 转发Tomcat Http</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r0gw08.html">iOS&period;AutoLayout&period;2&period;CustomView-with-AutoLayout</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1k2eez9.html">基本的socket编程的介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkx0nd8.html">关于WebApi 跨域问题的解决的方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gekne78.html">Codewars练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpl6zvq.html">Windows Azure Storage &lpar;25&rpar; Azure Append Blob</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z3p619.html">《CSS核心技术详解》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1o56zq.html">express respond&period;send 和 end的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjkjvg8.html">mac下更新自带的PHP版本到5&period;6</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpljo69.html">ubuntu&colon;通过封装验证码类库一步步安装php的gd扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zwedx9.html">MVC5中使用Log4Net</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1oe3yq.html">R语言-聚类与分类</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
